<template>
  <!--  <el-dialog title="收货地址" :visible.sync="dialogFormVisible">-->
  <el-container>
    <el-header style="width: 100%; height: 80px;font-size: 12px">

      <el-form :inline="true"  label-width="65px"  label-position="left">
        <el-row>
          <el-col :span="22">

          </el-col>
          <el-col :span="2">
            <el-form-item style="float: right" >
              <el-button type="success" @click="initList">查询</el-button>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="14"></el-col>
          <el-col :span="10" >
            <el-form-item style="float: right" >
              <el-button
                type="success"
                @click="toolbarButtonClickEvent('save')"
              >保存</el-button>
              <el-button type="success" @click="toolbarButtonClickEvent('insert')">添加</el-button>
              <el-button
                type="danger"
                @click="toolbarButtonClickEvent('delete')"
              >删除
              </el-button>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-header>
    <el-container  style="padding-top: 0px">
      <el-container>
        <el-main>
          <div class="mytable">
            <vxe-grid
              id="id"
              ref="xGrid"
              border
              resizable
              keep-source
              :align="'center'"
              :height="height"
              :auto-resize="true"
              :columns="tableColumn"
              highlight-current-row
              :data="list"
              :custom-config="{ storage: true }"
              :edit-config="{ trigger: 'click', mode: 'cell', showStatus: true}"
              highlight-hover-row
              :scroll-y="{enabled: true}"
              show-overflow
              show-header-overflow
            />
          </div>
        </el-main>
      </el-container>
    </el-container>
  </el-container>
</template>

<script>
import {getPgdBase,} from '@/api/jhzxgl/pgd'
import { mapGetters } from 'vuex'
import {ycldwcx, ycldwUpdate} from "@/api/jhzxgl/ycldw";
export default {
  name:'Ycldw',
  data() {
    return {
      queryParam: {
        dcCh:'',
      },
      inParam:{
        rqfw:'',
        zt:""
      },
      list: [],
      deptList: [],
      clickList: [],
      projectData:[],
      projectColumns: [
        {field: 'cbbm', title: '船号',width: 110},
        { field: 'wgbs', title: '完工标识', width: 80,
          slots:{
            default: 'wgbsEdit'
          },
        },
      ],
      dictData:{},
      height: '500px',
      tableColumn: [
        { type: 'checkbox', width: 50 },
        { type: 'seq', width: 40, title: '序号' },
        {
          field: 'kw',
          title: '所属垮位',editRender: { name: 'input' },
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
        {
          field: 'name',
          title: '垛位名称',editRender: { name: 'input' },
          width: 120,
          filters: [{ data: { checks: [], sVal: '', sMenu: '', fType1: '', fVal1: '', fMode: 'and', fType2: '', fVal2: '' } }],
          filterRender: { name: 'FilterCombination' }
        },
      ]
    }
  },
  computed: {
    ...mapGetters(['name', 'bmbm','apbm'])
  },
  created() {
    window.addEventListener('resize', this.getHeight)
    this.getHeight()
    this.initBase()
  },
  methods: {
    cellClickEvent({row}) {
      this.queryParam.dcCh = row.cbbm
      this.$refs.xDown4.hidePanel()
    },
    focusEvent4() {
      this.$refs.xDown4.showPanel()
    },
    keyupEvent4() {
      if (this.queryParam.dcCh) {
        this.projectData = this.projectData1.filter(row => row.cbbm.indexOf(this.queryParam.dcCh.toUpperCase()) > -1)
      } else {
        this.projectData = this.projectData1.slice(0)
      }

    },

    initBase(){
      getPgdBase({}).then(res=>{
        this.dictData = res.data
        this.dictData = res.data
        this.projectData=res.data.cbbm
        this.projectData1=res.data.cbbm
        const select=this.$refs.xGrid.getColumnByField('dcCh')
        const chList=[]
        res.data.cbbm.forEach(item=>{
          const data={
            label:item.cbbm,
            value:item.cbbm
          }
          chList.push(data)
        })
        select.editRender.options=chList

        const sldw = this.$refs.xGrid.getColumnByField('kw')
        sldw.editRender.options = this.dictData.qgkw
      })
    },
    initList() {
      ycldwcx(this.queryParam).then((res) => {
        this.list = res.data
      })
    },
    getHeight() {
      this.height = window.innerHeight - 190
    },
    toolbarButtonClickEvent(code) {
      const {
        insertRecords,
        removeRecords,
        updateRecords
      } = this.$refs.xGrid.getRecordset()
      switch (code) {
        case 'insert':
          this.$refs.xGrid.insertAt({

          }, -1).then(({ row }) => {
            this.$refs.xGrid.setActiveRow(row)
          })
          break
        case 'delete':
          this.$confirm('删除, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then((type) => {
            this.$refs.xGrid.removeCheckboxRow()
          })
          break
        case 'save':
          if (removeRecords.length !== 0) {
            ycldwUpdate({"remove":removeRecords}).then((response) => {
              if (response.success) {
                for (let i = 0; i < this.list.length; i++) {
                  if (removeRecords.indexOf(this.list[i]) !== -1) {
                    this.list.splice(i, 1)
                    i--
                  }
                }
                this.$message({ message: '保存成功！', type: 'success' })
                const xTable = this.$refs.xGrid
                xTable.loadData(this.initList())

              }
            })
          }

          if (updateRecords.length !== 0) {
            ycldwUpdate({"edit":updateRecords}).then((response) => {
              if (response.success) {
                const xTable = this.$refs.xGrid
                xTable.loadData(this.initList())
                this.$message({message: '保存成功！', type: 'success'})
              }
            })
          }
          if (insertRecords.length !== 0) {
            ycldwUpdate({"add":insertRecords}).then((response) => {
              if (response.success) {
                this.list = this.list.concat(insertRecords)
                const xTable = this.$refs.xGrid
                xTable.loadData(this.initList())
                this.$message({ message: '保存成功！', type: 'success' })
              }
            })
          }
          this.$message(
            `新增 ${insertRecords.length} 条，删除 ${removeRecords.length} 条，更新 ${updateRecords.length} 条`
          )
          this.clickList = []
          break
      }
    }
  }
}
</script>
<style lang="scss" scoped >

.el-header{margin:0;padding: 5px;height:auto;
  .el-input{
    width: 140px;
  }
  .el-select{
    width: 140px;
  }

}
.el-container{padding: 0;margin:0;}
.el-main{padding: 0;}
.el-col{padding: 0;height: 32px;}
.el-aside{background: #fff;padding: 0}
.el-container{padding: 0}
.el-row {}
.el-row:last-child {margin-bottom: 0; }

.tableStyles{
  background: #0a76a4;
}

.my-dropdown {
  width: 400px;
  height: 400px;
  background-color: #fff;
  border: 1px solid #dcdfe6;
  box-shadow: 0 0 6px 2px rgba(0, 0, 0, 0.1);
  font-size: 12px;

}
.mytable1{

}
.borderClass{

}
.vxe-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.el-input {
  display: inline-block !important;
  position: relative !important;
  width: auto;
}
.keyword-lighten {
  color: #000;
  background-color: #FFFF00;
}

.vxe-textarea--inner {
  line-height: inherit;
}
.el-form-item__label-wrap {
  margin-left: 0px !important;
  float: left;
}
.fontClass{
  font-size: 12px;
  font-weight: bold;
}


</style>
